namespace PkmnLib.Plugin.Gen7.Scripts.Pokemon;

[Script(ScriptCategory.Pokemon, "smack_down")]
public class SmackDownEffect : Script, IScriptChangeTypesForIncomingMove, IScriptIsFloating
{
    /// <inheritdoc />
    public void ChangeTypesForIncomingMove(IExecutingMove executingMove, IPokemon target, byte hitIndex,
        IList<TypeIdentifier> types)
    {
        var typeLibrary = target.Library.StaticLibrary.Types;

        if (executingMove.UseMove.MoveType.Name != "ground")
            return;
        // Remove all types that are immune to ground moves
        types.RemoveAll(x => typeLibrary.GetSingleEffectiveness(executingMove.UseMove.MoveType, x) == 0);
    }

    /// <inheritdoc />
    public void IsFloating(IPokemon pokemon, ref bool isFloating)
    {
        isFloating = false;
    }
}